<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
    <title>Device Configuration</title>

    <link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

    <script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

    <style>
        html {
            visibility: hidden;
        }
    </style>
</head>

<body>
    <div w3-include-html="meti_bst.html"></div>

    <div class="container">
        <div class="row">
            <main role="main" class="col-12 col-md-8 col-lg-6 pt-2">
                <div class="border border-primary p-2">
                    <h6 class="p-1">Device Configuration <span>(based on router)</span></h6>
                    <form id="formID">
                        <!-- Off Time -->
                        <div class="form-group p-1 m-0 row">
                            <label class="col-7 m-0 p-0">Packet version</label>
                            <input type="text" id="packet_version" class="col-5 form-control form-control-sm" readonly>
                        </div>

                        <!-- Off Time -->
                        <div class="form-group p-1 m-0 row">
                            <label class="col-7 m-0 p-0" for="sel_off_time">Mandatory router off time</label>
                            <select class="col-5 form-control form-control-sm" id="sel_off_time" name="sel_off_time"
                                size="1">
                            </select>
                        </div>

                        <!-- Boot-up time (wait time) -->
                        <div class="form-group p-1 m-0 row">
                            <label class="col-7 m-0 p-0" for="sel_boot_wait">Router boot-up time</label>
                            <select class="col-5 form-control form-control-sm" id="sel_boot_wait" name="sel_boot_wait"
                                size="1">
                            </select>
                        </div>

                        <!-- Ping interval -->
                        <div class="form-group p-1 m-0 row">
                            <label class="col-7 m-0 p-0" for="sel_ping_interval">Ping interval</label>
                            <select class="col-5 form-control form-control-sm" id="sel_ping_interval"
                                name="sel_ping_interval" size="1">
                            </select>
                        </div>

                        <!-- >Ping retries (before restart) -->
                        <div class="form-group p-1 m-0 row">
                            <label class="col-7 m-0 p-0" for="sel_ping_retries">Ping retries (before restart)</label>
                            <select class="col-5 form-control form-control-sm" id="sel_ping_retries"
                                name="sel_ping_retries" size="1">
                            </select>
                        </div>

                        <!-- Buttons -->
                        <div class="col-sm-12 form-group row mt-4 mb-1">
                            <button type="button" id="button_cancel"
                                class="btn btn-warning col ml-4 mr-4">Cancel</button>
                            <button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
                        </div>
                    </form>
                </div>
            </main>
        </div>
    </div>
</body>
</html>

<script>
    w3IncludeHTML();

    $(document).ready(function () {
        document.getElementsByTagName("html")[0].style.visibility = "visible";

        //Enable the validation engine
        $("#formID").validationEngine();

        $("#button_save").on("click", function () {
            // Check if the form passes the validation test....
            if ($("#formID").validationEngine('validate')) {
                var r = confirm("Save the configuration?");
                if (r == true) {
                    save_config();
                }
            }
        });

        $("#button_cancel").on("click", function () {
            location.reload();
        });

        setupSelects();

        function setupSelects() {
            // off time
            dataArray = [5, 10, 15, 30, 60]
            for (idx = 0; idx < dataArray.length; idx++) {
                var opt = $('<option></option>')
                    .val(dataArray[idx])
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(dataArray[idx] + ' secs');

                $("#sel_off_time").append(opt);
            }

            //Boot Time
            dataArray = [60, 90, 120, 180, 300, 600]
            for (idx = 0; idx < dataArray.length; idx++) {
                var opt = $('<option></option>')
                    .val(dataArray[idx])
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(dataArray[idx] + ' secs');

                $("#sel_boot_wait").append(opt);
            }

            //ping interval
            dataArray = [60, 120, 180, 300, 600]
            for (idx = 0; idx < dataArray.length; idx++) {
                var opt = $('<option></option>')
                    .val(dataArray[idx])
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(dataArray[idx] + ' secs');

                $("#sel_ping_interval").append(opt);
            }

            //ping retries
            dataArray = [1, 2, 3, 5, 10, 15]
            for (idx = 0; idx < dataArray.length; idx++) {
                var opt = $('<option></option>')
                    .val(dataArray[idx])
                    .addClass('dropdown-item')
                    .addClass('dd-item')
                    .text(dataArray[idx]);

                $("#sel_ping_retries").append(opt);
            }
        }

        function load_form_data() {
            // get data from the global parameters

            $("#packet_version").val(g_srm_config_db.pkt_ver);
            $("#sel_off_time").val(g_srm_config_db.off_time);
            $("#sel_boot_wait").val(g_srm_config_db.boot_wait);
            $("#sel_ping_interval").val(g_srm_config_db.ping_interval);
            $("#sel_ping_retries").val(g_srm_config_db.ping_retries);
        }

        function save_config() {
            var debug = 0;

            g_srm_config_db.off_time = $("#sel_off_time").val();
            g_srm_config_db.boot_wait = $("#sel_boot_wait").val();
            g_srm_config_db.ping_interval = $("#sel_ping_interval").val();
            g_srm_config_db.ping_retries = $("#sel_ping_retries").val();

            var url = "/updateSrmConfig";
            var type = 'POST';
            var data = {
                srm_config: JSON.stringify(g_srm_config_db)
            };

            $.ajax({
                url: url,
                type: type,
                data: data,
                success: function (response) {
                    if (debug == 1) {
                        console.log(response);
                    }
                    else {
                        // console.log(js_response);
                        var result = response.result;

                        if (result == 1) {
                            alert(response.message);
                        }
                        else if (result == 0) {
                            alert(response.message);
                        }
                    }
                },
                error: function (jqXHR, exception, response) {
                    alert('POST Error!');
                }
            });
        }
        //********* Call all start up functions after this line *******//
        updateSrmConfigFromFS(load_form_data);
    });
</script>